#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3100three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 3100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3100three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three31004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three31004xi = {
                1:'0x3009y-745z',
                2:'1009x2502y-1526z',
                3:'1013x745y-2833z',
                4:'1015x2290y-1825z',
                5:'101x99y-3096z',
                6:'1075x706y-2820z',
                7:'1094x2850y-533z',
                8:'10x122y-3097z',
                9:'10x15y-3099z',
                10:'1124x2648y-1152z',
                11:'1142x2250y-1800z',
                12:'1145x2459y-1499z',
                13:'118x284y-3084z',
                14:'123x811y-2989z',
                15:'1244x2794y-502z',
                16:'124x2445y-2060z',
                17:'1266x2596y-1123z',
                18:'1267x2203y-1774z',
                19:'1279x2409y-1472z',
                20:'130x114y-3095z',
                21:'1390x2148y-1749z',
                22:'1390x2729y-471z',
                23:'1406x2536y-1094z',
                24:'1411x2351y-1444z',
                25:'147x306y-3081z',
                26:'1511x2086y-1723z',
                27:'1534x2657y-441z',
                28:'1540x2286y-1417z',
                29:'1542x2468y-1065z',
                30:'157x3012y-715z',
                31:'160x126y-3093z',
                32:'1629x2018y-1697z',
                33:'1666x2213y-1389z',
                34:'1673x2576y-410z',
                35:'1675x2393y-1036z',
                36:'172x833y-2980z',
                37:'1743x1942y-1671z',
                38:'177x325y-3077z',
                39:'1788x2134y-1361z',
                40:'1804x2310y-1007z',
                41:'1808x2489y-379z',
                42:'180x2595y-1685z',
                43:'1854x1860y-1645z',
                44:'1907x2047y-1333z',
                45:'191x136y-3091z',
                46:'1929x2220y-978z',
                47:'1938x2393y-348z',
                48:'1961x1771y-1619z',
                49:'2021x1954y-1305z',
                50:'2050x2122y-948z',
                51:'2063x2291y-318z',
                52:'2064x1677y-1592z',
                53:'20x152y-3096z',
                54:'210x341y-3073z',
                55:'2130x1854y-1277z',
                56:'2161x1576y-1566z',
                57:'2165x2019y-919z',
                58:'2182x2182y-287z',
                59:'222x851y-2972z',
                60:'2234x1747y-1249z',
                61:'2274x1908y-889z',
                62:'2295x2067y-256z',
                63:'2333x1635y-1220z',
                64:'2378x1792y-859z',
                65:'2402x1945y-225z',
                66:'244x2792y-1323z',
                67:'245x355y-3069z',
                68:'246x2378y-1972z',
                69:'2476x1670y-829z',
                70:'2503x1818y-194z',
                71:'276x867y-2963z',
                72:'282x366y-3065z',
                73:'29x39y-3099z',
                74:'2x92y-3098z',
                75:'316x3006y-684z',
                76:'317x2599y-1659z',
                77:'321x374y-3060z',
                78:'331x879y-2954z',
                79:'34x182y-3094z',
                80:'35x760y-3005z',
                81:'361x378y-3055z',
                82:'373x2382y-1948z',
                83:'389x887y-2944z',
                84:'391x2789y-1295z',
                85:'403x380y-3050z',
                86:'43x2584y-1711z',
                87:'445x378y-3044z',
                88:'448x892y-2934z',
                89:'456x2595y-1633z',
                90:'474x2992y-654z',
                91:'489x373y-3038z',
                92:'501x2378y-1924z',
                93:'508x893y-2924z',
                94:'51x210y-3092z',
                95:'51x62y-3098z',
                96:'533x364y-3032z',
                97:'539x2777y-1266z',
                98:'570x889y-2914z',
                99:'595x2583y-1606z',
                100:'630x2367y-1899z',
                101:'631x2970y-624z',
                102:'633x882y-2903z',
                103:'687x2757y-1238z',
                104:'696x870y-2892z',
                105:'70x236y-3090z',
                106:'733x2564y-1580z',
                107:'759x2349y-1875z',
                108:'75x82y-3097z',
                109:'760x854y-2881z',
                110:'787x2938y-593z',
                111:'78x787y-2997z',
                112:'824x834y-2869z',
                113:'834x2729y-1210z',
                114:'872x2537y-1553z',
                115:'887x2323y-1850z',
                116:'888x809y-2857z',
                117:'93x261y-3087z',
                118:'941x2899y-563z',
                119:'951x779y-2845z',
                120:'97x2788y-1351z',
                121:'980x2693y-1181z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire3100three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire3100three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3100THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3100THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3100THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE3100THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3100THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three31004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3100THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3100THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3100THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three31004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three31004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3100THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3100THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3100THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3100three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                